<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDriverReportingGroup ArrayType
 * @subpackage Arrays
 */
class ArrayOfDriverReportingGroup extends AbstractStructArrayBase
{
    /**
     * The DriverReportingGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DriverReportingGroup[]
     */
    public $DriverReportingGroup;
    /**
     * Constructor method for ArrayOfDriverReportingGroup
     * @uses ArrayOfDriverReportingGroup::setDriverReportingGroup()
     * @param \StructType\DriverReportingGroup[] $driverReportingGroup
     */
    public function __construct(array $driverReportingGroup = array())
    {
        $this
            ->setDriverReportingGroup($driverReportingGroup);
    }
    /**
     * Get DriverReportingGroup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DriverReportingGroup[]|null
     */
    public function getDriverReportingGroup()
    {
        return isset($this->DriverReportingGroup) ? $this->DriverReportingGroup : null;
    }
    /**
     * Set DriverReportingGroup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DriverReportingGroup[] $driverReportingGroup
     * @return \ArrayType\ArrayOfDriverReportingGroup
     */
    public function setDriverReportingGroup(array $driverReportingGroup = array())
    {
        foreach ($driverReportingGroup as $arrayOfDriverReportingGroupDriverReportingGroupItem) {
            // validation for constraint: itemType
            if (!$arrayOfDriverReportingGroupDriverReportingGroupItem instanceof \StructType\DriverReportingGroup) {
                throw new \InvalidArgumentException(sprintf('The DriverReportingGroup property can only contain items of \StructType\DriverReportingGroup, "%s" given', is_object($arrayOfDriverReportingGroupDriverReportingGroupItem) ? get_class($arrayOfDriverReportingGroupDriverReportingGroupItem) : gettype($arrayOfDriverReportingGroupDriverReportingGroupItem)), __LINE__);
            }
        }
        if (is_null($driverReportingGroup) || (is_array($driverReportingGroup) && empty($driverReportingGroup))) {
            unset($this->DriverReportingGroup);
        } else {
            $this->DriverReportingGroup = $driverReportingGroup;
        }
        return $this;
    }
    /**
     * Add item to DriverReportingGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\DriverReportingGroup $item
     * @return \ArrayType\ArrayOfDriverReportingGroup
     */
    public function addToDriverReportingGroup(\StructType\DriverReportingGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DriverReportingGroup) {
            throw new \InvalidArgumentException(sprintf('The DriverReportingGroup property can only contain items of \StructType\DriverReportingGroup, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DriverReportingGroup[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DriverReportingGroup|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DriverReportingGroup|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DriverReportingGroup|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DriverReportingGroup|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DriverReportingGroup|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DriverReportingGroup
     */
    public function getAttributeName()
    {
        return 'DriverReportingGroup';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDriverReportingGroup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
