<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDriverScore ArrayType
 * @subpackage Arrays
 */
class ArrayOfDriverScore extends AbstractStructArrayBase
{
    /**
     * The DriverScore
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DriverScore[]
     */
    public $DriverScore;
    /**
     * Constructor method for ArrayOfDriverScore
     * @uses ArrayOfDriverScore::setDriverScore()
     * @param \StructType\DriverScore[] $driverScore
     */
    public function __construct(array $driverScore = array())
    {
        $this
            ->setDriverScore($driverScore);
    }
    /**
     * Get DriverScore value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DriverScore[]|null
     */
    public function getDriverScore()
    {
        return isset($this->DriverScore) ? $this->DriverScore : null;
    }
    /**
     * Set DriverScore value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DriverScore[] $driverScore
     * @return \ArrayType\ArrayOfDriverScore
     */
    public function setDriverScore(array $driverScore = array())
    {
        foreach ($driverScore as $arrayOfDriverScoreDriverScoreItem) {
            // validation for constraint: itemType
            if (!$arrayOfDriverScoreDriverScoreItem instanceof \StructType\DriverScore) {
                throw new \InvalidArgumentException(sprintf('The DriverScore property can only contain items of \StructType\DriverScore, "%s" given', is_object($arrayOfDriverScoreDriverScoreItem) ? get_class($arrayOfDriverScoreDriverScoreItem) : gettype($arrayOfDriverScoreDriverScoreItem)), __LINE__);
            }
        }
        if (is_null($driverScore) || (is_array($driverScore) && empty($driverScore))) {
            unset($this->DriverScore);
        } else {
            $this->DriverScore = $driverScore;
        }
        return $this;
    }
    /**
     * Add item to DriverScore value
     * @throws \InvalidArgumentException
     * @param \StructType\DriverScore $item
     * @return \ArrayType\ArrayOfDriverScore
     */
    public function addToDriverScore(\StructType\DriverScore $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DriverScore) {
            throw new \InvalidArgumentException(sprintf('The DriverScore property can only contain items of \StructType\DriverScore, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DriverScore[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DriverScore|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DriverScore|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DriverScore|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DriverScore|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DriverScore|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DriverScore
     */
    public function getAttributeName()
    {
        return 'DriverScore';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDriverScore
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
