<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfReportingGroupMember ArrayType
 * @subpackage Arrays
 */
class ArrayOfReportingGroupMember extends AbstractStructArrayBase
{
    /**
     * The ReportingGroupMember
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ReportingGroupMember[]
     */
    public $ReportingGroupMember;
    /**
     * Constructor method for ArrayOfReportingGroupMember
     * @uses ArrayOfReportingGroupMember::setReportingGroupMember()
     * @param \StructType\ReportingGroupMember[] $reportingGroupMember
     */
    public function __construct(array $reportingGroupMember = array())
    {
        $this
            ->setReportingGroupMember($reportingGroupMember);
    }
    /**
     * Get ReportingGroupMember value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ReportingGroupMember[]|null
     */
    public function getReportingGroupMember()
    {
        return isset($this->ReportingGroupMember) ? $this->ReportingGroupMember : null;
    }
    /**
     * Set ReportingGroupMember value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ReportingGroupMember[] $reportingGroupMember
     * @return \ArrayType\ArrayOfReportingGroupMember
     */
    public function setReportingGroupMember(array $reportingGroupMember = array())
    {
        foreach ($reportingGroupMember as $arrayOfReportingGroupMemberReportingGroupMemberItem) {
            // validation for constraint: itemType
            if (!$arrayOfReportingGroupMemberReportingGroupMemberItem instanceof \StructType\ReportingGroupMember) {
                throw new \InvalidArgumentException(sprintf('The ReportingGroupMember property can only contain items of \StructType\ReportingGroupMember, "%s" given', is_object($arrayOfReportingGroupMemberReportingGroupMemberItem) ? get_class($arrayOfReportingGroupMemberReportingGroupMemberItem) : gettype($arrayOfReportingGroupMemberReportingGroupMemberItem)), __LINE__);
            }
        }
        if (is_null($reportingGroupMember) || (is_array($reportingGroupMember) && empty($reportingGroupMember))) {
            unset($this->ReportingGroupMember);
        } else {
            $this->ReportingGroupMember = $reportingGroupMember;
        }
        return $this;
    }
    /**
     * Add item to ReportingGroupMember value
     * @throws \InvalidArgumentException
     * @param \StructType\ReportingGroupMember $item
     * @return \ArrayType\ArrayOfReportingGroupMember
     */
    public function addToReportingGroupMember(\StructType\ReportingGroupMember $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReportingGroupMember) {
            throw new \InvalidArgumentException(sprintf('The ReportingGroupMember property can only contain items of \StructType\ReportingGroupMember, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ReportingGroupMember[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ReportingGroupMember|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ReportingGroupMember|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ReportingGroupMember|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ReportingGroupMember|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ReportingGroupMember|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ReportingGroupMember
     */
    public function getAttributeName()
    {
        return 'ReportingGroupMember';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfReportingGroupMember
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
