<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AddBasicDriver' => '\\StructType\\AddBasicDriver',
            'AddBasicDriverResponse' => '\\StructType\\AddBasicDriverResponse',
            'TokenHeader' => '\\StructType\\TokenHeader',
            'AddDriver' => '\\StructType\\AddDriver',
            'Driver' => '\\StructType\\Driver',
            'EntityBase' => '\\StructType\\EntityBase',
            'AddDriverResponse' => '\\StructType\\AddDriverResponse',
            'UpdateDriver' => '\\StructType\\UpdateDriver',
            'UpdateDriverResponse' => '\\StructType\\UpdateDriverResponse',
            'DeleteDriver' => '\\StructType\\DeleteDriver',
            'DeleteDriverResponse' => '\\StructType\\DeleteDriverResponse',
            'GetDriver' => '\\StructType\\GetDriver',
            'GetDriverResponse' => '\\StructType\\GetDriverResponse',
            'GetDriverList' => '\\StructType\\GetDriverList',
            'GetDriverListResponse' => '\\StructType\\GetDriverListResponse',
            'ArrayOfDriver' => '\\ArrayType\\ArrayOfDriver',
            'GetDriverListFiltered' => '\\StructType\\GetDriverListFiltered',
            'GetDriverListFilteredResponse' => '\\StructType\\GetDriverListFilteredResponse',
            'GetDriverScoresInDateRange' => '\\StructType\\GetDriverScoresInDateRange',
            'GetDriverScoresInDateRangeResponse' => '\\StructType\\GetDriverScoresInDateRangeResponse',
            'ArrayOfDriverScore' => '\\ArrayType\\ArrayOfDriverScore',
            'DriverScore' => '\\StructType\\DriverScore',
            'GetDriverReportingGroupList' => '\\StructType\\GetDriverReportingGroupList',
            'GetDriverReportingGroupListResponse' => '\\StructType\\GetDriverReportingGroupListResponse',
            'ArrayOfDriverReportingGroup' => '\\ArrayType\\ArrayOfDriverReportingGroup',
            'DriverReportingGroup' => '\\StructType\\DriverReportingGroup',
            'ArrayOfReportingGroupMember' => '\\ArrayType\\ArrayOfReportingGroupMember',
            'ReportingGroupMember' => '\\StructType\\ReportingGroupMember',
            'GetDriverReportingGroup' => '\\StructType\\GetDriverReportingGroup',
            'GetDriverReportingGroupResponse' => '\\StructType\\GetDriverReportingGroupResponse',
            'ReportingGroupAddDriver' => '\\StructType\\ReportingGroupAddDriver',
            'ReportingGroupAddDriverResponse' => '\\StructType\\ReportingGroupAddDriverResponse',
            'ReportingGroupRemoveDriver' => '\\StructType\\ReportingGroupRemoveDriver',
            'ReportingGroupRemoveDriverResponse' => '\\StructType\\ReportingGroupRemoveDriverResponse',
        );
    }
}
